Makefile.am 10.3 KB
Newer Older
1 2 3 4 5
# Ganeti makefile
# - Indent with tabs only.
# - Keep files sorted; one line per file.
# - Directories in lib/ must have their own *dir variable (see hypervisor).
# - All directories must be listed DIRS.
Michael Hanselmann's avatar
Michael Hanselmann committed
6
# - Use autogen.sh to generate Makefile.in and configure script.
7 8 9 10 11

# Automake doesn't export these variables before version 1.10.
abs_top_builddir = @abs_top_builddir@
abs_top_srcdir = @abs_top_srcdir@

12
ACLOCAL_AMFLAGS = -I autotools
13
DOCBOOK_WRAPPER = $(top_srcdir)/autotools/docbook-wrapper
14
BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
15 16 17
REPLACE_VARS_SED = autotools/replace_vars.sed

hypervisordir = $(pkgpythondir)/hypervisor
18
httpdir = $(pkgpythondir)/http
Guido Trotter's avatar
Guido Trotter committed
19
confddir = $(pkgpythondir)/confd
20
rapidir = $(pkgpythondir)/rapi
21 22 23 24 25 26 27 28 29
toolsdir = $(pkglibdir)/tools
docdir = $(datadir)/doc/$(PACKAGE)

DIRS = \
	autotools \
	daemons \
	devel \
	doc \
	doc/examples \
Guido Trotter's avatar
Guido Trotter committed
30
	doc/examples/hooks \
31
	lib \
32
	lib/http \
33
	lib/hypervisor \
34
	lib/rapi \
Guido Trotter's avatar
Guido Trotter committed
35
	lib/confd \
36 37 38 39 40 41 42
	man \
	qa \
	scripts \
	test \
	test/data \
	tools

Iustin Pop's avatar
Iustin Pop committed
43
MAINTAINERCLEANFILES = \
44
	$(docpng) \
Iustin Pop's avatar
Iustin Pop committed
45 46
	$(maninput)

47 48 49
maintainer-clean-local:
	-rm -rf doc/api doc/build doc/html

50 51 52
CLEANFILES = \
	autotools/replace_vars.sed \
	devel/upload \
53
	doc/examples/bash_completion \
54 55 56
	doc/examples/ganeti.initd \
	doc/examples/ganeti.cron \
	lib/*.py[co] \
57
	lib/http/*.py[co] \
58
	lib/hypervisor/*.py[co] \
59
	lib/rapi/*.py[co] \
Iustin Pop's avatar
Iustin Pop committed
60 61
	$(man_MANS) \
	$(manhtml) \
62 63 64 65 66
	qa/*.py[co] \
	test/*.py[co] \
	stamp-directories \
	$(nodist_pkgpython_PYTHON)

67 68 69 70 71
BUILT_SOURCES = \
	ganeti \
	srclinks \
	lib/_autoconf.py

72 73 74 75 76
nodist_pkgpython_PYTHON = \
	lib/_autoconf.py

pkgpython_PYTHON = \
	lib/__init__.py \
Guido Trotter's avatar
Guido Trotter committed
77
	lib/asyncnotifier.py \
78 79 80 81 82 83 84
	lib/backend.py \
	lib/bdev.py \
	lib/bootstrap.py \
	lib/cli.py \
	lib/cmdlib.py \
	lib/config.py \
	lib/constants.py \
85
	lib/daemon.py \
86 87
	lib/errors.py \
	lib/jqueue.py \
88
	lib/jstore.py \
89 90 91 92 93 94 95 96 97
	lib/locking.py \
	lib/luxi.py \
	lib/mcpu.py \
	lib/objects.py \
	lib/opcodes.py \
	lib/rpc.py \
	lib/serializer.py \
	lib/ssconf.py \
	lib/ssh.py \
98
	lib/storage.py \
99 100
	lib/utils.py \
	lib/workerpool.py
101 102 103 104

hypervisor_PYTHON = \
	lib/hypervisor/__init__.py \
	lib/hypervisor/hv_base.py \
105
	lib/hypervisor/hv_chroot.py \
106
	lib/hypervisor/hv_fake.py \
Guido Trotter's avatar
Guido Trotter committed
107
	lib/hypervisor/hv_kvm.py \
108 109
	lib/hypervisor/hv_xen.py

110 111
rapi_PYTHON = \
	lib/rapi/__init__.py \
112 113 114
	lib/rapi/baserlib.py \
	lib/rapi/connector.py \
	lib/rapi/rlib2.py
115

116
http_PYTHON = \
117
	lib/http/__init__.py \
118
	lib/http/auth.py \
119 120
	lib/http/client.py \
	lib/http/server.py
121

Guido Trotter's avatar
Guido Trotter committed
122
confd_PYTHON = \
Guido Trotter's avatar
Guido Trotter committed
123
	lib/confd/__init__.py \
Guido Trotter's avatar
Guido Trotter committed
124 125
	lib/confd/server.py \
	lib/confd/querylib.py
126

Michael Hanselmann's avatar
Michael Hanselmann committed
127
docrst = \
128
	doc/admin.rst \
129
	doc/design-2.0.rst \
130
	doc/design-2.1.rst \
131
	doc/glossary.rst \
132
	doc/hooks.rst \
133
	doc/iallocator.rst \
134
	doc/index.rst \
135
	doc/install.rst \
136
	doc/rapi.rst \
137
	doc/security.rst
Michael Hanselmann's avatar
Michael Hanselmann committed
138

139 140 141 142 143 144 145 146 147 148
doc/html: $(docrst) $(docpng) doc/conf.py configure.ac
	@test -n "$(SPHINX)" || \
	    { echo 'sphinx-build' not found during configure; exit 1; }
	mkdir -p doc/build/doctrees
	PYTHONPATH=.:$(top_builddir) sphinx-build -q -b html \
	    -d doc/build/doctrees \
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
	    -D release="$(PACKAGE_VERSION)" \
	    $(top_srcdir)/doc doc/html
	touch "$@"
Iustin Pop's avatar
Iustin Pop committed
149

150 151 152
docdot = \
	doc/arch-2.0.dot

153
docpng = $(patsubst %.dot,%.png,$(docdot))
154

155
noinst_DATA = $(manhtml) doc/html
156

157
gnt_scripts = \
158 159 160 161 162 163 164 165
	scripts/gnt-backup \
	scripts/gnt-cluster \
	scripts/gnt-debug \
	scripts/gnt-instance \
	scripts/gnt-job \
	scripts/gnt-node \
	scripts/gnt-os

166 167 168 169 170 171 172 173
dist_sbin_SCRIPTS = \
	daemons/ganeti-noded \
	daemons/ganeti-watcher \
	daemons/ganeti-masterd \
	daemons/ganeti-confd \
	daemons/ganeti-rapi \
	$(gnt_scripts)

174 175 176 177 178 179 180
dist_tools_SCRIPTS = \
	tools/burnin \
	tools/cfgshell \
	tools/cfgupgrade \
	tools/lvmstrap

EXTRA_DIST = \
Iustin Pop's avatar
Iustin Pop committed
181
	$(MAINTAINERCLEANFILES) \
182 183
	NEWS \
	DEVNOTES \
Michael Hanselmann's avatar
Michael Hanselmann committed
184
	pylintrc \
185 186
	autotools/docbook-wrapper \
	devel/upload.in \
187
	$(docdot) \
188 189 190
	$(docrst) \
	doc/conf.py \
	doc/html \
191 192 193
	doc/examples/ganeti.initd.in \
	doc/examples/ganeti.cron.in \
	doc/examples/dumb-allocator \
Guido Trotter's avatar
Guido Trotter committed
194
	doc/examples/hooks/ethers \
195
	doc/locking.txt \
196 197 198 199 200
	test/testutils.py \
	test/mocks.py \
	$(dist_TESTS) \
	$(TEST_FILES) \
	man/footer.sgml \
Iustin Pop's avatar
Iustin Pop committed
201
	$(mansgml) $(maninput) \
202
	qa/ganeti-qa.py \
Michael Hanselmann's avatar
Michael Hanselmann committed
203
	qa/qa-sample.json \
204 205 206 207 208 209 210 211
	qa/qa_cluster.py \
	qa/qa_config.py \
	qa/qa_daemon.py \
	qa/qa_env.py \
	qa/qa_error.py \
	qa/qa_instance.py \
	qa/qa_node.py \
	qa/qa_os.py \
Oleksiy Mishchenko's avatar
Oleksiy Mishchenko committed
212
	qa/qa_rapi.py \
213 214 215 216 217
	qa/qa_tags.py \
	qa/qa_utils.py

man_MANS = \
	man/ganeti.7 \
218
	man/ganeti-masterd.8 \
219 220
	man/ganeti-noded.8 \
	man/ganeti-os-interface.7 \
221
	man/ganeti-rapi.8 \
222 223 224
	man/ganeti-watcher.8 \
	man/gnt-backup.8 \
	man/gnt-cluster.8 \
225
	man/gnt-debug.8 \
226
	man/gnt-instance.8 \
227
	man/gnt-job.8 \
228 229 230
	man/gnt-node.8 \
	man/gnt-os.8

Iustin Pop's avatar
Iustin Pop committed
231 232 233
mansgml = $(patsubst %.7,%.sgml,$(patsubst %.8,%.sgml,$(man_MANS)))
manhtml = $(patsubst %.sgml,%.html,$(mansgml))
maninput = $(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS))) $(patsubst %.html,%.html.in,$(manhtml))
234 235 236

TEST_FILES = \
	test/data/bdev-both.txt \
237
	test/data/bdev-8.3-both.txt \
238 239
	test/data/bdev-disk.txt \
	test/data/bdev-net.txt \
240 241
	test/data/proc_drbd8.txt \
	test/data/proc_drbd83.txt
242 243

dist_TESTS = \
244 245 246
	test/ganeti.bdev_unittest.py \
	test/ganeti.cli_unittest.py \
	test/ganeti.cmdlib_unittest.py \
247
	test/ganeti.config_unittest.py \
248
	test/ganeti.constants_unittest.py \
249
	test/ganeti.hooks_unittest.py \
250
	test/ganeti.http_unittest.py \
251
	test/ganeti.locking_unittest.py \
252
	test/ganeti.objects_unittest.py \
253
	test/ganeti.rapi.resources_unittest.py \
254 255 256 257
	test/ganeti.serializer_unittest.py \
	test/ganeti.ssh_unittest.py \
	test/ganeti.utils_unittest.py \
	test/ganeti.workerpool_unittest.py
258 259 260 261 262

nodist_TESTS =

TESTS = $(dist_TESTS) $(nodist_TESTS)

263
TESTS_ENVIRONMENT = PYTHONPATH=.:$(top_builddir) $(PYTHON)
264

265
all-local: stamp-directories devel/upload \
Iustin Pop's avatar
Iustin Pop committed
266
	doc/examples/bash_completion \
267 268 269 270 271 272
	doc/examples/ganeti.initd doc/examples/ganeti.cron

devel/upload: devel/upload.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
	chmod u+x $@

Iustin Pop's avatar
Iustin Pop committed
273
doc/examples/%: doc/examples/%.in stamp-directories \
274 275 276
		$(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@

277
doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) \
278 279 280 281 282 283 284 285 286 287 288
	lib/cli.py $(gnt_scripts) tools/burnin
	TMPDIR=`mktemp -d ./buildtmpXXXXXX` && \
	cp -r scripts lib tools $$TMPDIR && \
	( \
		CDIR=`pwd` && \
		cd $$TMPDIR && \
		mv lib ganeti && \
		PYTHONPATH=. $$CDIR/$(BUILD_BASH_COMPLETION) > $$CDIR/$@; \
	); \
	rm -rf $$TMPDIR

289
doc/%.png: doc/%.dot
Iustin Pop's avatar
Iustin Pop committed
290
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
291 292
	$(DOT) -Tpng -o $@ $<

Iustin Pop's avatar
Iustin Pop committed
293
man/%.7.in man/%.8.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
294
	@test -n "$(DOCBOOK2MAN)" || { echo 'docbook2man' not found during configure; exit 1; }
Michael Hanselmann's avatar
Michael Hanselmann committed
295
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2MAN)" $< $(notdir $(@:.in=)) $@
Iustin Pop's avatar
Iustin Pop committed
296 297

man/%.html.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
298
	@test -n "$(DOCBOOK2HTML)" || { echo 'docbook2html' not found during configure; exit 1; }
Michael Hanselmann's avatar
Michael Hanselmann committed
299
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2HTML) --nochunks" $< $(notdir $(@:.in=)) $@
Iustin Pop's avatar
Iustin Pop committed
300 301 302

man/%.7: man/%.7.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
303

Iustin Pop's avatar
Iustin Pop committed
304 305
man/%.8: man/%.8.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
306

Iustin Pop's avatar
Iustin Pop committed
307 308
man/%.html: man/%.html.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
309

310 311 312 313
lib/_autoconf.py: Makefile stamp-directories
	set -e; \
	{ echo '# This file is automatically generated, do not edit!'; \
	  echo '#'; \
Iustin Pop's avatar
Iustin Pop committed
314 315 316 317 318 319 320 321 322
	  echo ''; \
	  echo '"""Build-time configuration for Ganeti.'; \
	  echo '';\
	  echo 'This file is autogenerated by the build process.'; \
	  echo 'For any changes you need to re-run ./configure (and'; \
	  echo 'not edit by hand).'; \
	  echo ''; \
	  echo '"""'; \
	  echo ''; \
323 324 325 326 327 328 329 330 331 332 333 334 335 336 337
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
	  echo "SSH_INITD_SCRIPT = '$(SSH_INITD_SCRIPT)'"; \
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
338
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
Guido Trotter's avatar
Guido Trotter committed
339
	  echo "KVM_MIGRATION_PORT = '$(KVM_MIGRATION_PORT)'"; \
Guido Trotter's avatar
Guido Trotter committed
340
	  echo "SOCAT_PATH = '$(SOCAT_PATH)'"; \
341 342
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
	  echo "TOOLSDIR = '$(toolsdir)'"; \
343
	  echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
344 345 346 347 348 349 350 351 352 353 354
	} > $@

$(REPLACE_VARS_SED): Makefile stamp-directories
	set -e; \
	{ echo 's#@PREFIX@#$(prefix)#g'; \
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
355
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
Iustin Pop's avatar
Iustin Pop committed
356
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
357 358 359 360 361 362
	} > $@

# We need to create symlinks because "make distcheck" will not install Python
# files when building.
srclinks: stamp-directories
	set -e; \
363
	for i in man/footer.sgml $(pkgpython_PYTHON) $(hypervisor_PYTHON) \
Guido Trotter's avatar
Guido Trotter committed
364
			$(rapi_PYTHON) $(http_PYTHON) $(confd_PYTHON); do \
365 366 367 368
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
		fi; \
	done
369

Michael Hanselmann's avatar
Michael Hanselmann committed
370 371
.PHONY: ganeti
ganeti:
372
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
Michael Hanselmann's avatar
Michael Hanselmann committed
373

Iustin Pop's avatar
Iustin Pop committed
374 375 376 377 378 379 380
# a dist hook rule for catching revision control directories
distcheck-hook:
	if find $(top_distdir) | grep -F -e '.svn' -e '.git'; then \
		echo "Found revision control files in final archive" 1>&2 ; \
		exit 1; \
	fi

Iustin Pop's avatar
Iustin Pop committed
381
install-exec-local:
382
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
383 384
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
	  "$(DESTDIR)${localstatedir}/run/ganeti"
385 386 387 388 389

stamp-directories: Makefile
	@mkdir_p@ $(DIRS)
	touch $@

Iustin Pop's avatar
Iustin Pop committed
390 391 392
.PHONY: apidoc
apidoc:
	test -e doc/api || mkdir doc/api
Iustin Pop's avatar
Iustin Pop committed
393
	TMPDIR=`mktemp -d ` && { \
Iustin Pop's avatar
Iustin Pop committed
394 395
		cp -r scripts daemons lib $$TMPDIR && \
		( \
Iustin Pop's avatar
Iustin Pop committed
396
			CDIR=`pwd` && \
Iustin Pop's avatar
Iustin Pop committed
397 398
			cd $$TMPDIR && \
			mv lib ganeti && \
Iustin Pop's avatar
Iustin Pop committed
399
			epydoc -v --conf $$CDIR/epydoc.conf -o $$CDIR/doc/api \
Iustin Pop's avatar
Iustin Pop committed
400 401 402 403
		) ; \
		rm -rf $$TMPDIR ; \
	}

404 405 406 407 408 409 410
.PHONY: TAGS
TAGS:
	rm -f TAGS
	find . -path './lib/*.py' -o -path 'scripts/gnt-*' -o \
	  -path 'daemons/ganeti-*' -o -path 'tools/*' | \
	  etags -

411
# vim: set noet :